//CW3DInput.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//encapsulates initializing direct input and direct input devices. It also
//will read the current states of the devices. These include the mouse and
//keyboard

//define the file
#ifndef CW3DINPUT_H
#define CW3DINPUT_H

//include files
#include "dinput.h"

//the main input class
class CW3DInput
{
public:
	//constructor/deconstructor
	//sets defaults and releases memory
	CW3DInput();
	~CW3DInput();

	//initializes direct input and its devices
	//it returns a failed value if it failed
	HRESULT Initialize(HWND hWnd);

	//releases the memory for this class
	HRESULT Destroy();

	//it retrieves the data from the devices and
	//returns it as pointers
	HRESULT Process(BYTE* pKeyboardState[256],DIMOUSESTATE* pMouseState);
protected:
	//main direct input object
	IDirectInput8* m_Input;

	//the input devices(keyboard and mouse)
	IDirectInputDevice8* m_Keyboard;
	IDirectInputDevice8* m_Mouse;

	//global handle to window
	HWND m_hWnd;

	//error variable
	HRESULT hr;
};

#endif