//CW3DMD2Model.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//this class will load, update(animate) and render a 
//quake 2(.md2) model. this class however does not load
//the textures. that must be done manually

//define the file
#ifndef CW3DMD2MODEL_H
#define CW3DMD2MODEL_H

//include files
#include "d3d8.h"
#include "d3dx8.h"
#include "stdio.h"
#include "MD2Format.h"
#include "VertexFormats.h"

//define for model vertex
#define MD2MODELVERTEX VERTEX_XYZ_DIF_TEX
#define D3DFVF_MD2MODELVERTEX D3DFVF_VERTEX_XYZ_DIF_TEX

//structure for a model frame
struct sMD2ModelFrame
{
	MD2MODELVERTEX* pVertices;
};

//a .md2 model loading class. note: it does not load the textures
//that must be done in the code manually
class CW3DMD2Model
{
public:
	//constructor/deconstruct
	//sets defaults and releases memory
	CW3DMD2Model();
	~CW3DMD2Model();

	//loads the model and initializes the frames
	HRESULT Initialize(char* Filename,IDirect3DDevice8* pDevice);

	//releases the memory for this class
	HRESULT Destroy();

	//updates the model with the new frames of animation
	//it interpolates between the keyframes
	HRESULT Update(int Frame1,int Frame2,float interpolation,IDirect3DDevice8* pDevice);

	//render the model
	//takes two keyframes and an interpolation between them
	HRESULT Render(IDirect3DDevice8* pDevice);
protected:
	//the meshes for all the frames of animation
	sMD2ModelFrame* m_pFrames;
	int m_NumVertices;
	int m_NumFrames;

	//error variable
	HRESULT hr;

	//vertex buffer to render
	IDirect3DVertexBuffer8* m_VertexBuffer;
};

#endif