//MilkshapeFormat.h"
//Brent Gunning
//Copyright 2002 All Rights Reserved

//holds the milkshape structures used to load a binary
//formatted milkshape file

#ifndef MILKSHAPEFORMAT_H
#define MILKSHAPEFORMAT_H

#include "d3d8.h"

//milkshape structures
struct sMS3DHeader
{
	char ID[10];
	int Version;
};

struct sMS3DNumbers
{
	WORD NumVertices;
	WORD NumTriangles;
	WORD NumGroups;
	WORD NumMaterials;
};

struct sMS3DVertex
{
	BYTE Flags;
	float Position[3];
	char BoneID;
	BYTE ReferenceCount;
};

struct sMS3DTriangle
{
	WORD Flags;
	WORD VertexIndices[3];
	float VertexNormals[3][3];
	float s[3];
	float t[3];
	BYTE SmoothingGroup;
	BYTE GroupIndex;
};

struct sMS3DGroup
{
	BYTE Flags;
	WORD NumTriangles;
	WORD* TriangleIndices;
	char MaterialIndex;
};

struct sMS3DMaterial
{
    char Name[32];
    float Ambient[4];
    float Diffuse[4];
    float Specular[4];
    float Emissive[4];
    float Shininess;
    float Transparency;
    BYTE Mode;
    char TextureFilename[128];
    char AlphamapFilename[128];
};

struct sMS3DJoint
{
	BYTE Flags;
	char Name[32];
	char ParentName[32];
	float Rotation[3];
	float Translation[3];
	WORD NumRotationKeyframes;
	WORD NumTranslationKeyframes;
};

struct sMS3DKeyframe
{
	float Time;
	float Parameter[3];
};

#endif