//VertexFormats.h
//Brent Gunning
//Copyright 2002 All Rights Reserved

//These structures are d3d's flexible vertex structures that hold the 
//information for a vertex. Usually, when you want to use a structure, 
//you'll create to defines like so:
//
//#define MYVERTEX VERTEX_XYZ_NRM_DIF_TEX
//#define D3DFVF_MYVERTEX D3DFVF_VERTEX_XYZ_NRM_DIF_TEX

//define the file
#ifndef VERTEXFORMATS_H
#define VERTEXFORMATS_H

//include the d3d8 files for the vformats
#include "d3d8.h"
#include "d3dx8.h"

struct VERTEX_XYZ_NRM_DIF_TEX
{
	D3DXVECTOR3 pos;
	D3DXVECTOR3 nrm;
	DWORD dif;
	float tu,tv;
};
#define D3DFVF_VERTEX_XYZ_NRM_DIF_TEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_DIFFUSE|D3DFVF_TEX1)

struct VERTEX_XYZ_NRM_TEX
{
	D3DXVECTOR3 pos;
	D3DXVECTOR3 nrm;
	float tu,tv;
};
#define D3DFVF_VERTEX_XYZ_NRM_TEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)

struct VERTEX_XYZ_DIF_TEX
{
	D3DXVECTOR3 pos;
	DWORD dif;
	float tu,tv;
};
#define D3DFVF_VERTEX_XYZ_DIF_TEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)

#endif