//CW3DPlane.cpp
//Brent Gunning
//Copyright 2002 All Rights Reserved

//includ header
#include "../headers/CW3DPlane.h"

//normalizes the plane
HRESULT CW3DPlane::Normalize()
{
	//find the magnitude of the normal
	float l=(float)sqrt(a*a + b*b + c*c);

	//divide each value by the magnitude of the normal
	a=a/l;
	b=b/l;
	c=c/l;
	d=d/l;

	//return success
	return(S_OK);
}

//finds the distance to the plane from a point
//returns the distance
float CW3DPlane::PointDistance(float x, float y, float z)
{
	//return the distance using the plane equation ax+by+cz+d=0
	return((a*x)+(b*y)+(c*z)+d);
}

//releases the plane's memory
HRESULT CW3DPlane::Release()
{
	a=0;
	b=0;
	c=0;
	d=0;
	return(S_OK);
}
