//CW3DSkyBox.cpp
//Brent Gunning
//Copyright 2002 All Rights Reserved

#include "../headers/CW3DSkyBox.h"

//constructor/deconstructor
//sets defaults and releases memory
CW3DSkyBox::CW3DSkyBox()
{
	//set defaults (0's)
	m_VertexBuffer=0;
	m_Textures[0]=0;
	m_Textures[1]=0;
	m_Textures[2]=0;
	m_Textures[3]=0;
	m_Textures[4]=0;
	m_Textures[5]=0;
}
CW3DSkyBox::~CW3DSkyBox()
{
	//releases the class's memory
	Destroy();
}
//initializes the skybox. it takes a vector describing the size of the
//box in width, height and depth. It also takes the filenames of the 6
//textures. It basically just loads the textures and sets up the vbuffer
HRESULT CW3DSkyBox::Initialize(D3DXVECTOR3 vecSize,char* strTop,
					char* strBottom,char* strFront,
					char* strBack,char* strRight,char* strLeft,
					IDirect3DDevice8* pDevice)
{
	//destroy the class if it was already created
	Destroy();

	//create the vertex buffer
	if(FAILED(hr=pDevice->CreateVertexBuffer(sizeof(SKYBOXVERTEX)*24,
											D3DUSAGE_WRITEONLY,
											D3DFVF_SKYBOXVERTEX,
											D3DPOOL_MANAGED,
											&m_VertexBuffer)))
			return(hr);

	//create the vertices
	SKYBOXVERTEX Vertices[24];
	//top face
	Vertices[0].pos=D3DXVECTOR3(-vecSize.x/2,vecSize.y/2,-vecSize.z/2);
	Vertices[0].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[0].tu=0;
	Vertices[0].tv=1;
	Vertices[1].pos=D3DXVECTOR3(vecSize.x/2,vecSize.y/2,-vecSize.z/2);
	Vertices[1].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[1].tu=1;
	Vertices[1].tv=1;
	Vertices[2].pos=D3DXVECTOR3(-vecSize.x/2,vecSize.y/2,vecSize.z/2);
	Vertices[2].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[2].tu=0;
	Vertices[2].tv=0;
	Vertices[3].pos=D3DXVECTOR3(vecSize.x/2,vecSize.y/2,vecSize.z/2);
	Vertices[3].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[3].tu=1;
	Vertices[3].tv=0;
	//bottom face
	Vertices[4].pos=D3DXVECTOR3(-vecSize.x/2,-vecSize.y/2,-vecSize.z/2);
	Vertices[4].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[4].tu=0;
	Vertices[4].tv=0;
	Vertices[5].pos=D3DXVECTOR3(vecSize.x/2,-vecSize.y/2,-vecSize.z/2);
	Vertices[5].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[5].tu=1;
	Vertices[5].tv=0;
	Vertices[6].pos=D3DXVECTOR3(-vecSize.x/2,-vecSize.y/2,vecSize.z/2);
	Vertices[6].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[6].tu=0;
	Vertices[6].tv=1;
	Vertices[7].pos=D3DXVECTOR3(vecSize.x/2,-vecSize.y/2,vecSize.z/2);
	Vertices[7].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[7].tu=1;
	Vertices[7].tv=1;
	//left face
	Vertices[8].pos=D3DXVECTOR3(-vecSize.x/2,vecSize.y/2,-vecSize.z/2);
	Vertices[8].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[8].tu=1;
	Vertices[8].tv=0;
	Vertices[9].pos=D3DXVECTOR3(-vecSize.x/2,vecSize.y/2,vecSize.z/2);
	Vertices[9].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[9].tu=0;
	Vertices[9].tv=0;
	Vertices[10].pos=D3DXVECTOR3(-vecSize.x/2,-vecSize.y/2,-vecSize.z/2);
	Vertices[10].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[10].tu=1;
	Vertices[10].tv=1;
	Vertices[11].pos=D3DXVECTOR3(-vecSize.x/2,-vecSize.y/2,vecSize.z/2);
	Vertices[11].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[11].tu=0;
	Vertices[11].tv=1;
	//right face
	Vertices[12].pos=D3DXVECTOR3(vecSize.x/2,vecSize.y/2,-vecSize.z/2);
	Vertices[12].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[12].tu=0;
	Vertices[12].tv=0;
	Vertices[13].pos=D3DXVECTOR3(vecSize.x/2,vecSize.y/2,vecSize.z/2);
	Vertices[13].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[13].tu=1;
	Vertices[13].tv=0;
	Vertices[14].pos=D3DXVECTOR3(vecSize.x/2,-vecSize.y/2,-vecSize.z/2);
	Vertices[14].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[14].tu=0;
	Vertices[14].tv=1;
	Vertices[15].pos=D3DXVECTOR3(vecSize.x/2,-vecSize.y/2,vecSize.z/2);
	Vertices[15].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[15].tu=1;
	Vertices[15].tv=1;
	//front face
	Vertices[16].pos=D3DXVECTOR3(-vecSize.x/2,vecSize.y/2,vecSize.z/2);
	Vertices[16].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[16].tu=1;
	Vertices[16].tv=0;
	Vertices[17].pos=D3DXVECTOR3(vecSize.x/2,vecSize.y/2,vecSize.z/2);
	Vertices[17].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[17].tu=0;
	Vertices[17].tv=0;
	Vertices[18].pos=D3DXVECTOR3(-vecSize.x/2,-vecSize.y/2,vecSize.z/2);
	Vertices[18].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[18].tu=1;
	Vertices[18].tv=1;
	Vertices[19].pos=D3DXVECTOR3(vecSize.x/2,-vecSize.y/2,vecSize.z/2);
	Vertices[19].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[19].tu=0;
	Vertices[19].tv=1;
	//back face
	Vertices[20].pos=D3DXVECTOR3(-vecSize.x/2,vecSize.y/2,-vecSize.z/2);
	Vertices[20].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[20].tu=0;
	Vertices[20].tv=0;
	Vertices[21].pos=D3DXVECTOR3(vecSize.x/2,vecSize.y/2,-vecSize.z/2);
	Vertices[21].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[21].tu=1;
	Vertices[21].tv=0;
	Vertices[22].pos=D3DXVECTOR3(-vecSize.x/2,-vecSize.y/2,-vecSize.z/2);
	Vertices[22].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[22].tu=0;
	Vertices[22].tv=1;
	Vertices[23].pos=D3DXVECTOR3(vecSize.x/2,-vecSize.y/2,-vecSize.z/2);
	Vertices[23].dif=D3DCOLOR_ARGB(255,255,255,255);
	Vertices[23].tu=1;
	Vertices[23].tv=1;

	//lock the vertex buffer and copy the data. then unlock
	void* pData;
	if(FAILED(hr=m_VertexBuffer->Lock(0,0,(BYTE**)&pData,0)))
		return(hr);
	memcpy(pData,Vertices,sizeof(SKYBOXVERTEX)*24);
	if(FAILED(hr=m_VertexBuffer->Unlock()))
		return(hr);

	//load the textures
	if(FAILED(hr=D3DXCreateTextureFromFile(pDevice,strTop,&m_Textures[0])))
		return(hr);
	if(FAILED(hr=D3DXCreateTextureFromFile(pDevice,strBottom,&m_Textures[1])))
		return(hr);
	if(FAILED(hr=D3DXCreateTextureFromFile(pDevice,strLeft,&m_Textures[2])))
		return(hr);
	if(FAILED(hr=D3DXCreateTextureFromFile(pDevice,strRight,&m_Textures[3])))
		return(hr);
	if(FAILED(hr=D3DXCreateTextureFromFile(pDevice,strFront,&m_Textures[4])))
		return(hr);
	if(FAILED(hr=D3DXCreateTextureFromFile(pDevice,strBack,&m_Textures[5])))
		return(hr);

	//return success
	return(S_OK);
}
//this destroys the class's memory. It releases the vbuffer and 6 textures
HRESULT CW3DSkyBox::Destroy()
{
	//release the vertex buffer if created
	if(m_VertexBuffer)
	{
		m_VertexBuffer->Release();
		m_VertexBuffer=0;
	}
	//loop and release the textures
	for(int i=0;i<6;i++)
	{
		if(m_Textures[i])
		{
			m_Textures[i]->Release();
			m_Textures[i]=0;
		}
	}

	//return success
	return(S_OK);
}
//renders the skybox. it takes the position of the camera so it can align it
//to the skybox's position
HRESULT CW3DSkyBox::Render(D3DXVECTOR3 vecCameraPosition,IDirect3DDevice8* pDevice)
{
	//create the world matrix for the skybox
	//by translating it with the camera position
	D3DXMATRIX matWorld;
	D3DXMatrixIdentity(&matWorld);
	D3DXMatrixTranslation(&matWorld,vecCameraPosition.x,vecCameraPosition.y,vecCameraPosition.z);

	if(FAILED(hr=pDevice->SetTransform(D3DTS_WORLD,&matWorld)))
		return(hr);

	//set the buffer stream and fvf
	if(FAILED(hr=pDevice->SetStreamSource(0,m_VertexBuffer,sizeof(SKYBOXVERTEX))))
		return(hr);
	if(FAILED(hr=pDevice->SetVertexShader(D3DFVF_SKYBOXVERTEX)))
		return(hr);

	//set the textures and render each face
	for(int i=0;i<6;i++)
	{
		if(FAILED(hr=pDevice->SetTexture(0,m_Textures[i])))
			return(hr);
		if(FAILED(hr=pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,i*4,2)))
			return(hr);
	}
	//return success
	return(S_OK);
}